package com.cc.tools.activity

import android.content.BroadcastReceiver
import android.content.Context
import android.content.Intent
import com.cc.tools.observer.APkInstalledObserver

/**
 * APP安装监听
 *
 * @author cgh
 */
class PackageInstalledReceiver : BroadcastReceiver() {

    override fun onReceive(context: Context, intent: Intent) {
        val action = intent.action
        try {
            val packageName = intent.data!!.schemeSpecificPart
            if (Intent.ACTION_PACKAGE_REMOVED == action) {
                APkInstalledObserver.inst.uninstallApp(packageName)
            } else if (Intent.ACTION_PACKAGE_ADDED == action) {
                APkInstalledObserver.inst.installApp(packageName)
            }
        } catch (e: Exception) {
            e.printStackTrace()
        }
    }

}
