package com.cc.tools.adapter

import android.support.v7.widget.RecyclerView
import android.view.View
import android.widget.TextView
import butterknife.BindView
import butterknife.ButterKnife
import butterknife.OnClick
import com.cc.tools.R
import com.cc.tools.bean.CacheBean
import com.cc.tools.widget.reclyer.BaseHolder
import com.cc.tools.widget.reclyer.BaseViewAdapter
import com.cc.tools.widget.text.DownloadText


/**
 * 玩家招募
 */
class MainItemAdapter : BaseViewAdapter<CacheBean>() {

    override fun getBaseHolder(itemView: View, viewType: Int): BaseHolder<CacheBean> {
        return FindFansInfoItemHolder(itemView, this)
    }

    override fun getItemLayoutId(viewType: Int): Int {
        return R.layout.fragment_main_layout
    }

    class FindFansInfoItemHolder : BaseHolder<CacheBean> {

        @BindView(R.id.fragment_main_layout_name)
        lateinit var namTv: TextView
        @BindView(R.id.fragment_main_layout_size)
        lateinit var sizeTv: TextView

        @BindView(R.id.fragment_main_layout_down)
        lateinit var downTv: DownloadText

        constructor(itemView: View, adapter: RecyclerView.Adapter<*>) : super(itemView, adapter) {
            ButterKnife.bind(this, itemView)
        }

        override fun setEntityData(bean: CacheBean, position: Int) {
            super.setEntityData(bean, position)
            namTv.text = bean.archiveName
            sizeTv.text = bean.downloadSizeStr
            downTv.mDownUrl = bean.archiveUrl
            downTv.checkDownloadStatus(bean)
        }

        @OnClick(R.id.fragment_main_layout)
        fun onItemClick() {

        }
    }

}