package com.cc.tools.dlg

import android.content.Context
import android.view.View
import android.view.WindowManager
import android.widget.TextView
import com.cc.tools.R
import com.cc.tools.observer.Observers


class DlgCacheCover : BaseAlertDialog {

    constructor(ctx: Context) : super(ctx) {
    }

    var mCacheCoverNotice: CharSequence = ""
    var mListener: OnDlgCacheCoverListener? = null

    override val layoutRes: Int
        get() = R.layout.dlg_cache_cover

    override fun initViews(convertView: View) {
        window!!.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
        var titleView = convertView.findViewById(R.id.dlg_cache_cover_notice) as TextView
        titleView.text = mCacheCoverNotice
        var sureView = convertView.findViewById(R.id.dlg_sure)
        sureView!!.setOnClickListener({
            if (Observers.checkNull(mListener)) {
                mListener!!.onSure()
            }
            dismiss()
        })

        val closeView = convertView.findViewById(R.id.dlg_close)
        closeView.setOnClickListener { dismiss() }
    }

    interface OnDlgCacheCoverListener {
        fun onSure()
    }

}
