package com.cc.tools.dlg

import android.content.Context
import android.text.TextUtils
import android.view.View
import android.view.WindowManager
import android.widget.EditText
import android.widget.TextView
import com.cc.tools.R
import com.cc.tools.observer.Observers

class DlgCacheNew : BaseAlertDialog {

    constructor(ctx: Context) : super(ctx) {
    }

    var mListener: OnDlgCacheListener? = null
    var mTitle: String = ""


    override val layoutRes: Int
        get() = R.layout.dlg_cache_new

    override fun initViews(convertView: View) {
        window!!.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
        var titleView = convertView.findViewById(R.id.dlg_title) as TextView
        if(!TextUtils.isEmpty(mTitle)){
            titleView.text = mTitle
        }
        var inputView = convertView.findViewById(R.id.dlg_cache_new_input) as EditText
        var sureView = convertView.findViewById(R.id.dlg_sure)
        sureView!!.setOnClickListener(View.OnClickListener {
            val inputStr = inputView!!.text.toString().trim { it <= ' ' }
            if (TextUtils.isEmpty(inputStr)) {
                inputView!!.isFocusable = true
                inputView!!.isFocusableInTouchMode = true
                return@OnClickListener
            }
            if (Observers.checkNull(mListener)) {
                mListener!!.onDone(inputStr)
            }
            dismiss()
        })

        val closeView = convertView.findViewById(R.id.dlg_close)
        closeView.setOnClickListener { dismiss() }
    }

    interface OnDlgCacheListener {
        fun onDone(name: String)
    }

}
