package com.cc.tools.dlg

import android.content.Context
import android.text.SpannableString
import android.text.SpannableStringBuilder
import android.text.Spanned
import android.text.style.ForegroundColorSpan
import android.view.View
import android.view.WindowManager
import android.widget.TextView
import com.cc.tools.R
import com.cc.tools.network.download.DownloadFileBean

class DlgCacheUse : BaseAlertDialog {

    constructor(ctx: Context) : super(ctx) {
    }

    var mListener: OnDlgCacheUseListener? = null
    var mDownloadFileBean: DownloadFileBean? = null

    override val layoutRes: Int
        get() = R.layout.dlg_cache_use

    override fun initViews(convertView: View) {
        window!!.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
        window!!.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
        var noticeView = convertView.findViewById(R.id.dlg_cache_use_notice) as TextView

        var builder = SpannableStringBuilder()
        builder.append("是否使用存档：")
        var ss = SpannableString(mDownloadFileBean!!.title)
        ss.setSpan(ForegroundColorSpan(context.resources.getColor(R.color.color_common_red)), 0, ss.length, Spanned.SPAN_EXCLUSIVE_EXCLUSIVE)
        builder.append(ss)
        builder.append("？")
        builder.append("\n使用此存档将会覆盖本地存档，\n请先上传存档后使用~")
        noticeView.text = builder
        var sureView = convertView.findViewById(R.id.dlg_sure) as TextView
        sureView!!.setOnClickListener({
            mListener?.onUse(mDownloadFileBean!!)
            dismiss()
        })
        sureView.text = "使用"

        val closeView = convertView.findViewById(R.id.dlg_close) as TextView
        closeView.text = "取消"
        closeView.setOnClickListener {
            dismiss()
        }
    }

    interface OnDlgCacheUseListener {
        fun onUse(bean: DownloadFileBean)
    }

}