package com.cc.tools.dlg

import android.content.Context
import android.content.pm.PackageInfo
import android.content.pm.PackageManager
import android.view.View
import android.widget.TextView
import com.cc.tools.R
import com.cc.tools.application.BaseApplication
import com.cc.tools.bean.EntitySimpleAppInfoBean
import com.cc.tools.network.download.DownloadFileBean
import com.cc.tools.network.download.DownloadManager
import com.cc.tools.utils.AppManager
import com.cc.tools.utils.CommonHelper
import com.cc.tools.utils.ToastUtils
import java.io.File

/**
 * 普通更新
 *
 * @author Administrator
 */
class DlgCheckUpdateNormal : BaseAlertDialog {

    var mBean: EntitySimpleAppInfoBean? = null

    constructor(ctx: Context) : super(ctx) {
    }

    override val layoutRes: Int
        get() = R.layout.dlg_check_update

    override fun initViews(convertView: View) {
        val titleTv = convertView.findViewById(R.id.dlg_title) as TextView
        titleTv.text = mContext.getString(R.string.dlg_check_update_title_1, CommonHelper.formatSize(mBean!!.download_size))

        val versionTv = convertView.findViewById(R.id.dlg_check_update_version) as TextView
        versionTv.text = mContext.getString(R.string.dlg_update_content, mBean!!.version_name)

        val updateInfoTv = convertView.findViewById(R.id.dlg_check_update_content) as TextView
        updateInfoTv.text = mBean!!.updatesLog

        val sureView = convertView.findViewById(R.id.dlg_sure) as TextView
        sureView.setText(R.string.dlg_update_now)
        sureView.setOnClickListener(View.OnClickListener {
            val downloadInfo = DownloadManager.inst.getDownloadFileBean(mBean!!.download_url)
            if (downloadInfo != null && downloadInfo!!.state == DownloadManager.DOWNLOAD_ED && downloadInfo!!.currentBytes == mBean!!.download_size && File(downloadInfo.savePath).length() == mBean!!.download_size) {
                if (checkApp(downloadInfo)) {
                    return@OnClickListener
                }
            }
            addDownload()
        })

        val closeView = convertView.findViewById(R.id.dlg_close) as TextView
        closeView.setText(R.string.dlg_update_next)
        closeView.setOnClickListener { dismiss() }
    }

    private fun checkApp(downloadInfo: DownloadFileBean?): Boolean {
        dismiss()
        if (File(downloadInfo!!.savePath).exists()) {
            var unInstallInfo: PackageInfo? = null
            try {
                unInstallInfo = context.packageManager.getPackageArchiveInfo(downloadInfo.savePath, PackageManager.GET_ACTIVITIES)
                if (unInstallInfo!!.versionCode < mBean!!.version_code) {
                    return false
                }
            } catch (e: Exception) {
            }

            AppManager.installApp(mContext, downloadInfo.savePath)
            return true
        } else {
            DownloadManager.inst.deleteDownloadInfo(downloadInfo.url)
            ToastUtils.showLongToast(mContext, R.string.dlg_file_not_exist_1)
            return false
        }
    }

    private fun addDownload() {
        dismiss()
        var title = mBean!!.title + mBean!!.version_name
        var url = mBean!!.download_url
        var totalSize = mBean!!.download_size
        var pkgName = mBean!!.package_name
        var savePath = File(BaseApplication.mApplication!!.getExternalFilesDir(""), title).absolutePath
        DownloadManager.inst.addDownload(title, url, totalSize, pkgName, savePath, false)
        ToastUtils.showShortToast(mContext, R.string.toast_back_update)
    }

}
