package com.cc.tools.dlg

import android.content.Context
import android.view.View
import android.widget.ProgressBar
import android.widget.TextView
import com.cc.tools.R

open class DlgDownloadDqmr : BaseAlertDialog {

    var mProgressBar: ProgressBar? = null
    var mPointTv: TextView? = null
    var mListern: OnDlgDownloadDqmrListener? = null

    constructor(ctx: Context) : super(ctx) {
        setCancelable(true)
    }

    override val layoutRes: Int
        get() = R.layout.dlg_download_dqmr

    override fun initViews(convertView: View) {
        mProgressBar = convertView.findViewById(R.id.dlg_download_dqmr_progress) as ProgressBar
        mPointTv = convertView.findViewById(R.id.dlg_download_dqmr_point) as TextView
        setPoint(0, 100)
        val closeView = convertView.findViewById(R.id.dlg_close)
        closeView.setOnClickListener {
            dismiss()
            mListern?.onCancel()
        }
    }

    fun setPoint(progress: Long, total: Long) {
        mProgressBar!!.max = (total / 10).toInt()
        mProgressBar!!.progress = (progress / 10).toInt()
        mPointTv!!.text = String.format("%.1f%%", progress * 100.0f / total)
    }

    interface OnDlgDownloadDqmrListener {

        fun onCancel()

    }

}