package com.cc.tools.dlg

import android.content.Context
import android.text.TextUtils
import android.view.View
import android.view.WindowManager
import android.widget.EditText
import android.widget.ImageView
import android.widget.TextView
import com.cc.tools.R
import com.cc.tools.observer.Observers
import com.cc.tools.utils.GlideUtils
import com.cc.tools.utils.MachineInfoUtil


/**
 * 图形验证码对话框
 *
 * @author mingkg21
 */
class DlgVerify : BaseAlertDialog {

    constructor(ctx: Context) : super(ctx) {
    }

    var mPhone: String = ""
    var mVerifyImgUrl: String = ""
    var mInputView: EditText? = null
    var mVerifyIV: ImageView? = null
    var mSureView: TextView? = null
    var mOnCommitVerifyCodeAction: OnCommitVerifyCodeAction? = null

    val verifyImgUrl: String
        get() = mVerifyImgUrl + "/?v=" + System.currentTimeMillis() + "&phone=" + mPhone + "&deviceNo=" + MachineInfoUtil.instance.IMEI

    override val layoutRes: Int
        get() = R.layout.dlg_verify

    override fun initViews(convertView: View) {
        window!!.clearFlags(WindowManager.LayoutParams.FLAG_ALT_FOCUSABLE_IM)
        mInputView = convertView.findViewById(R.id.dlg_input_verify_code) as EditText
        mVerifyIV = convertView.findViewById(R.id.dlg_get_verify_img) as ImageView
        GlideUtils.ins.loadBitmap(context, verifyImgUrl, mVerifyIV!!)
        mVerifyIV!!.setOnClickListener { refreshVerifyCode() }
        mSureView = convertView.findViewById(R.id.dlg_sure) as TextView
        mSureView!!.setText(R.string.dlg_commit)
        mSureView!!.setOnClickListener(View.OnClickListener {
            val inputStr = mInputView!!.text.toString().trim { it <= ' ' }
            if (TextUtils.isEmpty(inputStr)) {
                mInputView!!.isFocusable = true
                mInputView!!.isFocusableInTouchMode = true
                return@OnClickListener
            }
            if (Observers.checkNull(mOnCommitVerifyCodeAction)) {
                mOnCommitVerifyCodeAction!!.onDone(mPhone, inputStr)
            }
        })

        val mCloseView = convertView.findViewById(R.id.dlg_close)
        mCloseView.setOnClickListener { dismiss() }
    }

    fun refreshVerifyCode() {
        if (mVerifyIV != null) {
            GlideUtils.ins.loadBitmap(context, verifyImgUrl, mVerifyIV!!)
        }
        mInputView?.text!!.clear()
    }

    interface OnCommitVerifyCodeAction {
        fun onDone(phone: String, code: String)
    }

}
