package com.cc.tools.fragment

import android.content.Context
import android.view.LayoutInflater
import android.view.View
import com.cc.tools.R
import com.cc.tools.bean.EntitySimpleAppInfoBean
import com.cc.tools.dlg.DlgCheckUpdateNormal
import com.cc.tools.fragment.base.TitleFragment
import com.cc.tools.model.IMainModel
import com.cc.tools.presenter.IMainPresenter

class MainFragment : TitleFragment<IMainPresenter>, IMainModel{

    var mMainHeaderFragment: MainHeaderFragment = MainHeaderFragment()
    var mDlgCheckUpdateNormal: DlgCheckUpdateNormal? = null

    constructor() {
        mLeftIcon = 0
        mTitleLayoutRes = R.layout.actionbar_title_layout
        mTitleRes = R.string.text_tools_main
        mLayoutRes = R.layout.layout_recycle_frame
        mIPresenterClass = IMainPresenter::class
    }

    override fun onAttach(context: Context?) {
        super.onAttach(context)
        var fragment = CCFragment()
        fragment.lazyLoad()
        activity.supportFragmentManager.beginTransaction().add(android.R.id.content, fragment).commit()
    }

//    override val adapter: BaseViewAdapter<CacheBean>
//        get() = MainItemAdapter()

    override fun initView(inflater: LayoutInflater?, container: View?) {
        super.initView(inflater, container)
        childFragmentManager.beginTransaction()
                .add(R.id.layout_recycle_frame, mMainHeaderFragment)
                .commit()
    }

//    override fun addHeaderOrFooterViews(recyclerView: CustomRecyclerView, inflater: LayoutInflater?) {
//        super.addHeaderOrFooterViews(recyclerView, inflater)
//        recyclerView.setDividerHeight(0f)
//        var headerView = inflater?.inflate(R.layout.layout_recycle_frame, null)
//        recyclerView.addHeaderView(headerView!!)
//        HandlerUtils.post(mHandler, Runnable {
//            childFragmentManager.beginTransaction()
//                    .add(R.id.layout_recycle_frame, mMainHeaderFragment)
//                    .commit()
//        })
//        recyclerView.setPadding(0, 0, 0, DisplayUtils.dip2px(activity, 70f))
//    }

    override fun onAppUpdate(bean: EntitySimpleAppInfoBean) {
        mDlgCheckUpdateNormal = DlgCheckUpdateNormal(activity)
        mDlgCheckUpdateNormal?.mBean = bean
        mDlgCheckUpdateNormal?.show()
    }


//    override fun onCCHiddenChanged(hidden: Boolean) {
//        try {
//            if (hidden) {
//                mCustomRecyclerView?.setPadding(0, 0, 0, 0)
////                mMarginView?.visibility = View.GONE
//            } else {
//                mCustomRecyclerView?.setPadding(0, 0, 0, DisplayUtils.dip2px(activity, 70f))
////                mMarginView?.visibility = View.VISIBLE
//            }
//        } catch (e: Exception) {
//
//        }
//    }

    override fun onDestroy() {
        super.onDestroy()
        mDlgCheckUpdateNormal?.dismiss()
    }
}