package com.cc.tools.network.protocol

import com.cc.tools.bean.EntitySimpleAppInfoBean
import com.cc.tools.network.ProtocolBase
import com.cc.tools.network.api.Cache
import com.cc.tools.utils.JSONUtils
import com.cc.tools.utils.MachineInfoUtil
import org.json.JSONArray
import org.json.JSONObject
import java.util.*

class ProtocolAppCheckUpdates : ProtocolBase<MutableList<EntitySimpleAppInfoBean>> {

    constructor() {}

    init {
        mActionName = Cache.CHECK_UPDATE
    }

    override fun parseResult(resultObj: String): MutableList<EntitySimpleAppInfoBean> {
        return JSONUtils.parseArray(resultObj, EntitySimpleAppInfoBean::class.java)
    }

    override fun setupKeyValues(kvMap: TreeMap<String, Any>) {
        val jsonArray = JSONArray()
        try {
            val jsonObject = JSONObject()
            jsonObject.put("package_name", mContext!!.packageName)
            jsonObject.put("version_name", MachineInfoUtil.instance.SSH_CLIENT_VERSION_NAME)
            jsonObject.put("version_code", MachineInfoUtil.instance.SSH_CLIENT_VERSION_CODE)
            jsonArray.put(jsonObject)
        } catch (e: Exception) {
        }
        kvMap.put("apps_json", jsonArray)
    }
}
