package com.cc.tools.network.protocol.cache

import com.cc.tools.network.ProtocolBase
import com.cc.tools.network.api.Cache
import com.cc.tools.utils.CacheUtils
import com.cc.tools.utils.JSONUtils
import java.util.*

/**
 * 更新用户游戏存档
 *
 * @author cgh
 */
class ProtocolArchiveAdd : ProtocolBase<String>() {


    var archiveName = ""
    var archiveUrl = ""
    var archiveSize: Long = 0

    init {
        mActionName = Cache.V3_ARCHIVE_ADD_USER_ARCHIVE
    }

    override fun parseResult(resultObj: String): String {
        return JSONUtils.parseObject(resultObj, String::class.java)!!
    }

    override fun setupKeyValues(kvMap: TreeMap<String, Any>) {
        kvMap.put("packageName", CacheUtils.PKG)
        kvMap.put("archiveName", archiveName)
        kvMap.put("archiveUrl", archiveUrl)
        kvMap.put("archiveSize", archiveSize)
    }

}