package com.cc.tools.network.protocol.cache

import com.cc.tools.bean.CacheBean
import com.cc.tools.network.ProtocolBase
import com.cc.tools.network.api.Cache
import com.cc.tools.utils.CacheUtils
import com.cc.tools.utils.JSONUtils
import java.util.*

class ProtocolArchiveUserList : ProtocolBase<MutableList<CacheBean>>() {

    var page = 1
    var page_size = 1

    init {
        mActionName = Cache.V3_ARCHIVE_USER_LIST
    }

    override fun parseResult(resultObj: String): MutableList<CacheBean> {
        return JSONUtils.parseArray(resultObj, CacheBean::class.java)
    }

    override fun setupKeyValues(kvMap: TreeMap<String, Any>) {
        kvMap.put("packageName", CacheUtils.PKG)
        kvMap.put("page", page)
        kvMap.put("page_size", page_size)
    }

}