package com.cc.tools.network.protocol.login

import com.cc.tools.bean.user.UserLoginBean
import com.cc.tools.network.ProtocolBase
import com.cc.tools.network.api.UserApi
import com.cc.tools.observer.UserLoginObserver
import com.cc.tools.utils.JSONUtils
import com.cc.tools.utils.user.UserManager
import java.util.*


/**
 * 登录
 *
 * @author cgh
 */
class ProtocolLogin : ProtocolBase<UserLoginBean>() {

    var account = ""
    var password = ""

    init {
        mActionName = UserApi.Login.LOGIN
    }

    override fun parseResult(resultObj: String): UserLoginBean {
        var userLoginBean = JSONUtils.parseObject(resultObj, UserLoginBean::class.java)
        UserManager.setUserLoginBean(userLoginBean)
        UserLoginObserver.inst.onLoginSuccess()
        return userLoginBean!!
    }

    override fun setupKeyValues(kvMap: TreeMap<String, Any>) {
        kvMap.put("username", account)
        kvMap.put("password", password)
        kvMap.put("bbs_flag", false)
    }

}