package com.cc.tools.network.protocol.login

import com.cc.tools.bean.user.UserLoginBean
import com.cc.tools.network.ProtocolBase
import com.cc.tools.network.api.UserApi
import com.cc.tools.observer.UserLoginObserver
import com.cc.tools.utils.JSONUtils
import com.cc.tools.utils.user.UserManager
import java.util.*


/**
 * 手机号注册
 *
 * @author cgh
 */
class ProtocolRegisterPhone : ProtocolBase<UserLoginBean> {

    var phone = ""
    var validate_code = ""
    var password = ""

    constructor(){
        mActionName = UserApi.Login.REGISTER_PHONE
    }

    override fun parseResult(resultObj: String): UserLoginBean {
        var userLoginBean = JSONUtils.parseObject(resultObj, UserLoginBean::class.java)
        UserManager.setUserLoginBean(userLoginBean)
        UserLoginObserver.inst.onLoginSuccess()
        return userLoginBean!!
    }

    override fun setupKeyValues(kvMap: TreeMap<String, Any>) {
        kvMap.put("phone", phone)
        kvMap.put("validate_code", validate_code)
        kvMap.put("password", password)
    }

}