package com.cc.tools.network.protocol.login

import android.text.TextUtils
import com.cc.tools.bean.VerImgCodeBean
import com.cc.tools.network.ProtocolBase
import com.cc.tools.network.api.SmsApi
import com.cc.tools.utils.JSONUtils
import java.util.*


/**
 * 发送验证码
 *
 * @author mingkg21
 */
class ProtocolSendSmsNew : ProtocolBase<VerImgCodeBean> {

    var phone: String = ""
    var smsType: String = ""
    var validateCode: String = ""

    constructor() {
        mActionName = SmsApi.SEND_REGISTER_SMS
    }

    override fun parseResult(resultObj: String): VerImgCodeBean {
        return JSONUtils.parseObject(resultObj, VerImgCodeBean::class.java)!!
    }

    override fun setupKeyValues(kvMap: TreeMap<String, Any>) {
        kvMap.put("phone", phone)
        if (!TextUtils.isEmpty(validateCode)) {
            kvMap.put("validateCode", validateCode)
        }
        kvMap.put("smsType", smsType)
    }

    companion object {
        val TYPE_RESET_PWD = "sendResetPasswordSms"//重置密码时发送验证码
        val TYPE_REGISTER_PHONE = "sendRegisterSms"//手机注册时时发送验证码
    }

}
