package com.cc.tools.observer

import com.cc.tools.model.common.InstallModel

class APkInstalledObserver : Observers<InstallModel>() {

    fun installApp(pkg: String) {
        invokeMethod("installApp", mutableListOf(pkg))
    }

    fun uninstallApp(pkg: String) {
        invokeMethod("uninstallApp", mutableListOf(pkg))
    }

    companion object {

        private var mInst: APkInstalledObserver? = null

        val inst: APkInstalledObserver
            get() {
                synchronized(APkInstalledObserver::class.java) {
                    if (mInst == null) {
                        mInst = APkInstalledObserver()
                    }
                }
                return mInst!!
            }
    }

}
