package com.cc.tools.observer

import android.os.Handler
import android.os.Looper
import com.cc.tools.R
import com.cc.tools.application.BaseApplication

/**
 * 验证码倒计时
 */
class CodeTimeObserver : Observers<CodeTimeObserver.OnCodeTimeDownAction>() {

    private var TIME = 60
    private var TIME_NOW = TIME
    private var TEXT = BaseApplication.mApplication.getString(R.string.text_login_get_code)
    var CLICK_ABLE: Boolean = false
        get() {
            return !mRunning
        }
    var mHandler = Handler(Looper.getMainLooper())
    var mRunning = false

    override fun addListener(t: OnCodeTimeDownAction) {
        super.addListener(t)
        var text = ""
        if (!mRunning) {
            text = TEXT
        } else {
            text = TIME_NOW.toString()
        }
        onTimeContinued(text)
    }

    fun startAnimation() {
        if (mRunning) return
        onTimeStart(TIME.toString())
        mRunning = true
        animation(1000)
    }

    fun animation(time: Long) {
        mHandler.postDelayed(Runnable {
            if (TIME_NOW == 0) {
                TIME_NOW = TIME
                mRunning = false
                onTimeEnd(TEXT)
            } else {
                animation(1000)
                TIME_NOW--
                if (TIME_NOW != TIME) {
                    onTimeContinued(TIME_NOW.toString())
                }
            }
        }, time)
    }

    fun onTimeStart(str: String) {
        invokeMethod("onTimeStart", mutableListOf(str))
    }

    fun onTimeContinued(str: String) {
        invokeMethod("onTimeContinued", mutableListOf(str))
    }

    fun onTimeEnd(str: String) {
        invokeMethod("onTimeEnd", mutableListOf(str))
    }

    companion object {

        private var mInst: CodeTimeObserver? = null

        val instance: CodeTimeObserver
            get() {
                synchronized(CodeTimeObserver::class.java) {
                    if (null == mInst) {
                        mInst = CodeTimeObserver()
                    }
                }
                return mInst!!
            }
    }

    interface OnCodeTimeDownAction {

        fun onTimeStart(str: String)

        fun onTimeContinued(str: String)

        fun onTimeEnd(str: String)
    }
}