package com.cc.tools.observer


/**
 * 用户登录成功
 *
 * @author cgh
 */
class UserLoginObserver : Observers<UserLoginObserver.UserLoginObserverAction>() {

    fun onLoginSuccess() {
        invokeMethod("onLoginSuccess", mutableListOf())
    }

    interface UserLoginObserverAction {
        fun onLoginSuccess()
    }

    companion object {

        private var mInst: UserLoginObserver? = null

        val inst: UserLoginObserver
            get() {
                synchronized(UserLoginObserver::class.java) {
                    if (mInst == null) {
                        mInst = UserLoginObserver()
                    }
                }
                return mInst!!
            }
    }
}
