package com.cc.tools.observer

/**
 * 用户注销
 *
 * @author cgh
 */
class UserLogoutObserver : Observers<UserLogoutObserver.UserLogOutObserverAction>() {

    fun onLogOutSuccess() {
        if (mListeners != null) {
            val size = mListeners.size
            for (i in 0 until size) {
                try {
                    mListeners[i].onLogOutSuccess()
                } catch (e: Exception) {
                    e.printStackTrace()
                }

            }
        }
    }

    interface UserLogOutObserverAction {
        fun onLogOutSuccess()
    }

    companion object {

        private var mInst: UserLogoutObserver? = null

        val inst: UserLogoutObserver
            get() {
                synchronized(UserLogoutObserver::class.java) {
                    if (mInst == null) {
                        mInst = UserLogoutObserver()
                    }
                }
                return mInst!!
            }
    }
}
