package com.cc.tools.presenter

import com.cc.tools.bean.CacheBean
import com.cc.tools.bean.EntitySimpleAppInfoBean
import com.cc.tools.model.IMainModel
import com.cc.tools.network.IProtocolListener
import com.cc.tools.network.ResponseBean
import com.cc.tools.network.protocol.ProtocolAppCheckUpdates
import com.cc.tools.network.protocol.cache.ProtocolArchiveHotList

class IMainPresenter : IPresenterImp<IMainModel> {

    constructor() {}

    override fun initData() {
    }

    override fun loadData() {
        super.loadData()
//        loadPage(1, 10, object : IProtocolListener<MutableList<CacheBean>> {
//            override fun onStart() {
//            }
//
//            override fun onSuccess(bean: ResponseBean<MutableList<CacheBean>>) {
//                if (bean.results == null) {
//                    bean.results = mutableListOf()
//                }
//                mIModelImp?.onFirstRequestSuccess(bean)
//            }
//
//            override fun onFailure(bean: ResponseBean<MutableList<CacheBean>>) {
//                mIModelImp?.onFirstRequestFail(bean)
//            }
//
//            override fun onFinish(bean: ResponseBean<MutableList<CacheBean>>) {
//            }
//        })
        checkUpdate()
    }

    fun checkUpdate() {
        var protocol = ProtocolAppCheckUpdates()
        protocol.mContext = mCtx
        protocol.mListener = object : IProtocolListener<MutableList<EntitySimpleAppInfoBean>> {
            override fun onStart() {
            }

            override fun onSuccess(bean: ResponseBean<MutableList<EntitySimpleAppInfoBean>>) {
                if (bean?.results == null || bean.results!!.isEmpty()) {
                    return
                } else {
                    mIModelImp?.onAppUpdate(bean.results!![0])
                }
            }

            override fun onFailure(bean: ResponseBean<MutableList<EntitySimpleAppInfoBean>>) {
            }

            override fun onFinish(bean: ResponseBean<MutableList<EntitySimpleAppInfoBean>>) {
            }
        }
        protocol.postRequest()
    }

    fun loadPage(page: Int, pageSize: Int, iProtocolListener: IProtocolListener<MutableList<CacheBean>>) {
        var protocol = ProtocolArchiveHotList()
        protocol.mContext = mCtx
        protocol.mListener = iProtocolListener
        protocol.page = page
        protocol.page_size = pageSize
        protocol.postRequest()
    }

    override fun getNextData(page: Int, pageSize: Int) {
//        var protocol = ProtocolArchiveHotList()
//        protocol.mContext = mCtx
//        protocol.mListener = object : IProtocolListener<MutableList<CacheBean>> {
//            override fun onStart() {
//            }
//
//            override fun onSuccess(bean: ResponseBean<MutableList<CacheBean>>) {
//                mIModelImp?.onNextRequestSuccess(bean)
//            }
//
//            override fun onFailure(bean: ResponseBean<MutableList<CacheBean>>) {
//                mIModelImp?.onNextRequestFail(bean)
//            }
//
//            override fun onFinish(bean: ResponseBean<MutableList<CacheBean>>) {
//            }
//        }
//        protocol.page = page
//        protocol.page_size = pageSize
//        protocol.postRequest()
    }
}