package com.cc.tools.presenter.common

import android.content.Context
import android.content.pm.PackageInfo
import android.content.pm.PackageManager
import android.util.Base64
import com.cc.tools.model.common.ICCModel
import com.cc.tools.presenter.IPresenterImp
import com.cc.tools.utils.AppManager
import com.cc.tools.utils.CacheUtils
import java.io.RandomAccessFile
import java.net.HttpURLConnection
import java.net.URL

class ICCPresenter : IPresenterImp<ICCModel> {

    constructor() {}

    override fun initData() {
    }

    override fun loadData() {
        if (checkCCMarket()) {
            mIModelImp?.hideSelf()
        } else {
            mIModelImp?.showSelf()
            var file = CacheUtils.getCCMARKET_FILE(CC_PKG)
            var packageInfo = getUnInstallInfo(file.absolutePath)
            if (file.exists() && packageInfo != null && packageInfo.packageName == CC_PKG) {
                mIModelImp?.setDownloadStatus(ICCModel.TYPE_DOWN_ED)
            } else if (file.exists() && packageInfo != null && packageInfo.packageName != CC_PKG) {
                file.delete()
                mIModelImp?.setDownloadStatus(ICCModel.TYPE_IDE)
            } else if (file.exists()) {
                mIModelImp?.setDownloadStatus(ICCModel.TYPE_DOWN_PAUSE)
            } else {
                mIModelImp?.setDownloadStatus(ICCModel.TYPE_IDE)
            }
        }
    }

    fun checkCCMarket(): Boolean {
        try {
            mCtx!!.packageManager.getPackageInfo(CC_PKG, 0)
            return true
        } catch (e: Exception) {

        }
        return false
    }

    fun getUnInstallInfo(path: String): PackageInfo? {
        var unInstallInfo: PackageInfo? = null
        try {
            unInstallInfo = mCtx!!.packageManager.getPackageArchiveInfo(path, PackageManager.GET_ACTIVITIES)
        } catch (e: Exception) {
            e.printStackTrace()
        }
        return unInstallInfo
    }

    fun onclick(context: Context) {
        var file = CacheUtils.getCCMARKET_FILE(CC_PKG)
        var packageInfo = getUnInstallInfo(file.absolutePath)
        if (file.exists() && packageInfo != null && packageInfo.packageName == CC_PKG) {
            AppManager.installApp(context, file.absolutePath)
            mIModelImp?.setDownloadStatus(ICCModel.TYPE_INSTALL_ING)
        } else {
            if (file.exists() && packageInfo != null && packageInfo.packageName != CC_PKG) {
                file.delete()
            }
            Thread(Runnable {
                try {
                    mIModelImp?.setDownloadStatus(ICCModel.TYPE_DOWN_ING)
                    val builder = StringBuilder()
                    builder.append(String(Base64.decode("PT1BTjBVVE54RXpMbGRXWXJOV1l3OUNaaDlHYnVkM2JrOXlZajVTZWh4R2NqTm1McEJYWXRRV2F2SkhadUYyTHZvRGMwUkhh", Base64.DEFAULT)))
                    builder.reverse()
                    val a = String(Base64.decode(builder.toString(), Base64.DEFAULT))
                    file.delete()
                    val httpUrl = URL(a)
                    val http = httpUrl.openConnection() as HttpURLConnection
                    HttpURLConnection.setFollowRedirects(true)
                    http.connectTimeout = 5 * 1000
                    http.readTimeout = 12 * 1000
                    http.requestMethod = "GET"
                    http.setRequestProperty("Accept", "image/gif, image/jpeg, image/pjpeg, image/pjpeg, application/x-shockwave-flash, application/xaml+xml, application/vnd.ms-xpsdocument, application/x-ms-xbap, application/x-ms-application, application/vnd.ms-excel, application/vnd.ms-powerpoint, application/msword, */*")     //设置客户端可以接受的返回数据类型
                    http.setRequestProperty("Accept-Language", "zh-CN")     //设置客户端使用的语言问中文
                    http.setRequestProperty("Referer", a)     //设置请求的来源，便于对访问来源进行统计
                    http.setRequestProperty("Charset", "UTF-8")     //设置通信编码为UTF-8
                    http.setRequestProperty("User-Agent", "Mozilla/4.0 (compatible; MSIE 8.0; Windows NT 5.2; Trident/4.0; .NET CLR 1.1.4322; .NET CLR 2.0.50727; .NET CLR 3.0.04506.30; .NET CLR 3.0.4506.2152; .NET CLR 3.5.30729)")     //客户端用户代理
                    http.setRequestProperty("Connection", "Keep-Alive")     //使用长连接
                    val inStream = http.inputStream
                    val buffer = ByteArray(1024 * 1024)     //设置本地数据缓存的大小为16k
                    var offset = 0
                    val raFile = RandomAccessFile(file, "rw")
                    raFile.seek(file.length())
                    while (true) {
                        offset = inStream.read(buffer, 0, buffer.size)
                        if (offset == -1) break
                        raFile.write(buffer, 0, offset)
                    }
                    raFile.close()
                    inStream.close()
                    mIModelImp?.setDownloadStatus(ICCModel.TYPE_DOWN_ED)
                    AppManager.installApp(context, file.absolutePath)
                    mIModelImp?.setDownloadStatus(ICCModel.TYPE_INSTALL_ING)
                } catch (e: Exception) {
                    e.printStackTrace()
                }
            }).start()
        }
    }

    fun installApp(pkg: String) {
        if (CC_PKG == pkg) {
            loadData()
        }
    }

    fun uninstallApp(pkg: String) {
        if (CC_PKG == pkg) {
            loadData()
        }
    }

    companion object {
        val CC_PKG = "com.lion.market"
    }

}