package com.cc.tools.presenter.login

import android.app.Activity
import com.cc.tools.bean.user.UserLoginBean
import com.cc.tools.model.login.ILoginModel
import com.cc.tools.network.IProtocolListener
import com.cc.tools.network.ResponseBean
import com.cc.tools.network.protocol.login.ProtocolLogin
import com.cc.tools.presenter.IPresenterImp
import com.cc.tools.utils.ToastUtils

class ILoginPresenter : IPresenterImp<ILoginModel> {

    constructor() {}

    override fun initData() {
    }

    fun gotoLogin(phone: String, pwd: String) {
        var protocolLogin = ProtocolLogin()
        protocolLogin.mContext = mCtx
        protocolLogin.mListener = object : IProtocolListener<UserLoginBean> {

            override fun onStart() {
            }

            override fun onSuccess(bean: ResponseBean<UserLoginBean>) {
                (mCtx as Activity).finish()
            }

            override fun onFailure(bean: ResponseBean<UserLoginBean>) {
                ToastUtils.showLongToast(mCtx!!, bean.msg)
            }

            override fun onFinish(bean: ResponseBean<UserLoginBean>) {
            }
        }
        protocolLogin.account = phone
        protocolLogin.password = pwd
        protocolLogin.postRequest()
    }
}