package com.cc.tools.presenter.login

import android.app.Activity
import android.text.TextUtils
import com.cc.tools.bean.VerImgCodeBean
import com.cc.tools.model.login.IResetPwdModel
import com.cc.tools.network.IProtocolListener
import com.cc.tools.network.ResponseBean
import com.cc.tools.network.protocol.login.ProtocolResetPasswordByPhone
import com.cc.tools.network.protocol.login.ProtocolSendSmsNew
import com.cc.tools.presenter.IPresenterImp
import com.cc.tools.utils.ToastUtils

class IResetPwdPresenter : IPresenterImp<IResetPwdModel> {

    constructor() {}

    override fun initData() {
    }

    fun gotoCommit(phone: String, code: String, pwd: String) {
        var protocol = ProtocolResetPasswordByPhone()
        protocol.mContext = mCtx
        protocol.mListener = object : IProtocolListener<String> {

            override fun onStart() {
            }

            override fun onSuccess(bean: ResponseBean<String>) {
                ToastUtils.showLongToast(mCtx!!, "密码修改成功~")
                (mCtx as Activity).finish()
            }

            override fun onFailure(bean: ResponseBean<String>) {
                ToastUtils.showLongToast(mCtx!!, bean.msg)
            }

            override fun onFinish(bean: ResponseBean<String>) {
            }
        }
        protocol.phone = phone
        protocol.validate_code = code
        protocol.new_password = pwd
        protocol.postRequest()
    }

    fun sendCode(phone: String, validateCode: String) {
        val protocolSendSms = ProtocolSendSmsNew()
        protocolSendSms.mListener = object : IProtocolListener<VerImgCodeBean> {

            override fun onStart() {
            }

            override fun onSuccess(bean: ResponseBean<VerImgCodeBean>) {
                var imgUrl = bean.results?.imgUrl
                if (TextUtils.isEmpty(imgUrl)) {
                    mIModelImp?.hideDlgVerify()
                    mIModelImp?.sendCodeSuccess()
                } else {
                    mIModelImp?.showDlgVerify(phone, imgUrl!!)
                }
            }

            override fun onFailure(bean: ResponseBean<VerImgCodeBean>) {
                mIModelImp?.refreshVerifyCode(bean)
            }

            override fun onFinish(bean: ResponseBean<VerImgCodeBean>) {

            }

        }
        protocolSendSms.mContext = mCtx
        protocolSendSms.phone = phone
        protocolSendSms.smsType = ProtocolSendSmsNew.TYPE_REGISTER_PHONE
        protocolSendSms.validateCode = validateCode
        protocolSendSms.postRequest()
    }

}