package com.cc.tools.utils

import android.app.Activity

import com.cc.tools.observer.Observers


class ActivityCacheUtils : Observers<Activity>() {

    fun finish() {
        for (i in mListeners.indices) {
            try {
                val activity = mListeners[i]
                if (!activity.isFinishing) {
                    activity.finish()
                }
            } catch (e: Exception) {
                e.printStackTrace()
            }

        }
    }

    companion object {

        private var mInst: ActivityCacheUtils? = null
        val inst: ActivityCacheUtils
            get() {
                synchronized(ActivityCacheUtils::class.java) {
                    if (mInst == null) {
                        mInst = ActivityCacheUtils()
                    }
                }
                return mInst!!
            }
    }

}
