package com.cc.tools.utils

import android.content.Context
import android.content.Intent
import android.net.Uri
import java.io.File


object AppManager {

    /**
     * 卸载APP
     */
    fun uninstallApp(context: Context, pkg: String) {
        try {
            val uri = Uri.parse("package:" + pkg)
            val intent = Intent(Intent.ACTION_DELETE, uri)
            context.startActivity(intent)
        } catch (e: Exception) {
        }

    }

    /**
     * 安装APP
     */
    fun installApp(context: Context, path: String) {
        try {
            chmod777(context, path)
            val file = File(path)
            val intent = Intent(Intent.ACTION_VIEW)
            intent.setDataAndType(Uri.fromFile(file), "application/vnd.android.package-archive")
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            context.startActivity(intent)
        } catch (e: Exception) {
            e.printStackTrace()
        }

    }

    fun chmod777(context: Context, path: String) {
        if (path.startsWith(context.filesDir.absolutePath)) {
            try {
                Runtime.getRuntime().exec("chmod 777 " + path)
                val file = File(path)
                chmod777(context, file.parent)
            } catch (e: Exception) {
                e.printStackTrace()
            }

        }
    }

    fun openApp(context: Context, pkg: String): Boolean {
        val intent = context.packageManager.getLaunchIntentForPackage(pkg)
        if (intent != null) {
            intent.flags = Intent.FLAG_ACTIVITY_NEW_TASK
            context.startActivity(intent)
            return true
        }
        return false
    }


    fun openUrl(context: Context, url: String): Boolean {
        try {
            val intent = Intent()
            intent.action = "android.intent.action.VIEW"
            val content_url = Uri.parse(url)
            intent.data = content_url
            intent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK)
            context.startActivity(intent)
            return true
        } catch (e: Exception) {
            e.printStackTrace()
            return false
        }

    }

    fun startActivity(context: Context, uri: String): Boolean {
        try {
            context.startActivity(Intent.parseUri(uri, 0))
            return true
        } catch (e: Exception) {
            return false
        }

    }

}
