package com.cc.tools.utils

import android.app.Application
import android.content.Context
import android.text.TextUtils
import java.io.IOException
import java.util.zip.ZipEntry
import java.util.zip.ZipFile

class ChannelManage {
    /**
     * 读取渠道号
     * @return
     */
    var channel = ""

    fun initApplication(application: Application){
        if (TextUtils.isEmpty(channel)) {
            channel = getChannelFromApk(application)//获取APK
        }
    }

    companion object {

        private val FILE_NAME = "channel"
        private val KEY = "channel"

        private var mChannelManage: ChannelManage? = null

        @Synchronized
        fun getInstance(): ChannelManage {
            if (mChannelManage == null) {
                mChannelManage = ChannelManage()
            }
            return mChannelManage!!
        }

        /**
         * 从apk中获取版本信息
         * @param context
         * @return
         */

        fun getChannelFromApk(context: Context): String {
            val appInfo = context.applicationInfo
            val sourceDir = appInfo.sourceDir
            val key = "META-INF/channel~"
            val key2 = "META-INF/channel_"
            var zipfile: ZipFile? = null
            var res = ""
            try {
                zipfile = ZipFile(sourceDir)
                val entries = zipfile.entries()
                while (entries.hasMoreElements()) {
                    val entry = entries.nextElement() as ZipEntry
                    val entryName = entry.name
                    if (entryName.startsWith(key2) || entryName.startsWith(key)) {
                        res = entryName.substring(key.length)
                        //				Logger.i(TAG, "channel is : " + res);
                        break
                    }
                }
            } catch (e: IOException) {
                e.printStackTrace()
            } finally {
                if (zipfile != null) {
                    try {
                        zipfile.close()
                    } catch (e: IOException) {
                        e.printStackTrace()
                    }

                }
            }
            return res
        }
    }
}
