package com.cc.tools.utils

import android.annotation.SuppressLint

@SuppressLint("SimpleDateFormat", "DefaultLocale")
object CommonHelper {

    val isAndroid5_0: Boolean
        get() = android.os.Build.VERSION.SDK_INT >= 21

    /**
     * 3.5.0版本开始去掉小数点后
     *
     * @param size
     * @return
     */
    fun formatSize(size: Long): String {
        return if (size >= 0 && size < 1024) {
            String.format("%sB", size)
        } else if (size >= 1024 && size < 1024 * 1024) {
            String.format("%sK", size / 1024)
        } else {
            String.format("%sM", size / 1024 / 1024)
        }
    }

    fun formatDownloadStatusSize(size: Long): String {
        return if (size >= 0 && size < 1024) {
            String.format("%.0fB", java.lang.Float.valueOf(size.toString()))
        } else if (size >= 1024 && size < 1024 * 1024) {
            String.format("%.1fKB", size * 1.0f / 1024)
        } else {
            String.format("%.1fMB", size * 1.0f / 1024f / 1024f)
        }
    }

    fun formatDownCount(count: Long): String {
        return if (count > 100 * 100) {
            String.format("%.1f万次", count / (100 * 100.0f))
        } else if (count > 10 * 100 * 100 * 100) {
            String.format("%.1f千万次", count / (10f * 100f * 100f * 100.0f))
        } else {
            count.toString() + "次"
        }
    }

    fun formatHighLevelGameSize(size: Long): String {
        return (size / 1024 / 1024).toString() + "M"
    }

}
