package com.cc.tools.utils

import android.content.Context
import android.util.DisplayMetrics
import android.view.WindowManager


object DisplayUtils{

    fun dip2px(context: Context, dpValue: Float): Int {
        val scale = context.resources.displayMetrics.density
        return (dpValue * scale + 0.5f).toInt()
    }

    fun px2dip(context: Context, pxValue: Float): Int {
        val scale = context.resources.displayMetrics.density
        return (pxValue / scale + 0.5f).toInt()
    }

    fun sp2px(context: Context, pxValue: Float): Float {
        val scale = context.resources.displayMetrics.scaledDensity
        return pxValue * scale
    }

    fun px2sp(context: Context, pxValue: Float): Float {
        val scale = context.resources.displayMetrics.scaledDensity
        return pxValue / scale
    }

    fun getDensity(context: Context): Float {
        return context.resources.displayMetrics.density
    }

    /**
     * 获取屏幕像素
     *
     * @param context
     * @return
     */
    fun getDisplayMetrics(context: Context): DisplayMetrics {
        val displayMetrics = DisplayMetrics()
        val windowManager = context
                .getSystemService(Context.WINDOW_SERVICE) as WindowManager
        windowManager.defaultDisplay.getMetrics(displayMetrics)
        return displayMetrics
    }

}