package com.cc.tools.utils

import android.os.Handler
import android.os.Message

object HandlerUtils {

    fun sendEmptyMessage(handler: Handler, what: Int) {
        sendEmptyMessageDelayed(handler, what, 0)
    }

    fun sendEmptyMessageDelayed(handler: Handler?, what: Int, delayMillis: Long) {
        handler?.sendEmptyMessageDelayed(what, delayMillis)
    }

    fun sendMessageDelayed(handler: Handler?, msg: Message, delayMillis: Long) {
        handler?.sendMessageDelayed(msg, delayMillis)
    }

    fun obtainMessage(what: Int, arg1: Int, arg2: Int): Message {
        val message = Message()
        message.what = what
        message.arg1 = arg1
        message.arg2 = arg2
        return message
    }

    fun post(handler: Handler, r: Runnable) {
        postDelayed(handler, r, 0)
    }

    fun postDelayed(handler: Handler?, r: Runnable, delayMillis: Long) {
        handler?.postDelayed(r, delayMillis)
    }

    fun removeMessages(handler: Handler?, what: Int) {
        handler?.removeMessages(what)
    }

    fun removeCallbacks(handler: Handler?, r: Runnable) {
        handler?.removeCallbacks(r)
    }

    fun removeCallbacksAndMessages(handler: Handler?) {
        handler?.removeCallbacksAndMessages(null)
    }

    fun release(handler: Handler) {
        removeCallbacksAndMessages(handler)
    }

}
