package com.cc.tools.utils

import android.app.Activity
import android.content.Context
import android.view.View
import android.view.inputmethod.InputMethodManager


object IMMUtils {

    fun hideSoftInput(activity: Activity) {
        try {
            val inputMethodManager = activity.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
            inputMethodManager.hideSoftInputFromWindow(activity.currentFocus!!.windowToken, 0)
        } catch (e: Exception) {
            e.printStackTrace()
        }

    }

    fun hideSoftInput(context: Context, view: View) {
        try {
            val inputMethodManager = context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
            inputMethodManager.hideSoftInputFromWindow(view.windowToken, 0)
        } catch (e: Exception) {
            e.printStackTrace()
        }

    }

    fun showSoftInput(activity: Activity) {
        try {
            val inputMethodManager = activity.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
            inputMethodManager.toggleSoftInputFromWindow(activity.currentFocus!!.windowToken, 0, InputMethodManager.SHOW_FORCED)
        } catch (e: Exception) {
            e.printStackTrace()
        }

    }

    fun showSoftInput(context: Context, view: View) {
        try {
            val inputMethodManager = context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
            inputMethodManager.showSoftInput(view, InputMethodManager.SHOW_FORCED)
        } catch (e: Exception) {
            e.printStackTrace()
        }

    }

    fun showSoftDialogInput(context: Context, view: View) {
        try {
            val inputMethodManager = context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager
            inputMethodManager.showSoftInput(view, InputMethodManager.SHOW_IMPLICIT)
        } catch (e: Exception) {
            e.printStackTrace()
        }

    }

    fun fixInputMethodManagerLeak(context: Context?) {
        if (context == null) {
            return
        }
        try {
            val imm = context.getSystemService(Context.INPUT_METHOD_SERVICE) as InputMethodManager ?: return
            var obj_get: Any? = null
            val f_mCurRootView = imm.javaClass.getDeclaredField("mCurRootView")
            val f_mServedView = imm.javaClass.getDeclaredField("mServedView")
            val f_mNextServedView = imm.javaClass.getDeclaredField("mNextServedView")
            if (f_mCurRootView.isAccessible == false) {
                f_mCurRootView.isAccessible = true
            }
            obj_get = f_mCurRootView.get(imm)
            if (obj_get != null) {
                f_mCurRootView.set(imm, null)
            }
            if (f_mServedView.isAccessible == false) {
                f_mServedView.isAccessible = true
            }
            obj_get = f_mServedView.get(imm)
            if (obj_get != null) {
                f_mServedView.set(imm, null)
            }
            if (f_mNextServedView.isAccessible == false) {
                f_mNextServedView.isAccessible = true
            }
            obj_get = f_mNextServedView.get(imm)
            if (obj_get != null) {
                f_mNextServedView.set(imm, null)
            }
        } catch (t: Throwable) {
            t.printStackTrace()
        }

    }

}
