package com.cc.tools.utils

import com.alibaba.fastjson.JSON
import com.alibaba.fastjson.parser.Feature
import com.alibaba.fastjson.parser.deserializer.ExtraProcessor

object JSONUtils {

    private val features = arrayOf(Feature.InitStringFieldAsEmpty)

    fun <T> parseArray(text: String?, clazz: Class<T>): MutableList<T> {
        var text = text
        var list: MutableList<T>? = null
        try {
            if (text == null) text = ""
            list = JSON.parseArray(text, clazz)
        } catch (e: Exception) {
            e.printStackTrace()
        }

        if (list == null) {
            list = mutableListOf()
        }
        return list
    }

    fun <T> parseObject(text: String?, clazz: Class<T>): T? {
        var text = text
        var t: T? = null
        try {
            Logger.i("parseObject >>> " + clazz)
            if (text == null) text = ""
            t = JSON.parseObject(text, clazz, *features)
        } catch (e: Exception) {
            e.printStackTrace()
        }

        if (t == null) {
            try {
                t = clazz.newInstance()
            } catch (e: InstantiationException) {
                e.printStackTrace()
            } catch (e: IllegalAccessException) {
                e.printStackTrace()
            }

        }
        return t
    }

    fun toJSONString(o: Any): String {
        return JSON.toJSONString(o)
    }

    fun <T> CheckNull(cls: Class<T>, o: Any): T? {
        var t: T? = o as T
        if (t == null) {
            try {
                t = cls.newInstance()
            } catch (e: InstantiationException) {
                e.printStackTrace()
            } catch (e: IllegalAccessException) {
                e.printStackTrace()
            }

        }
        return t
    }

    internal class MyExtraProcessor : ExtraProcessor {
        override fun processExtra(`object`: Any, key: String, value: Any?) {
            if (value == null) {
                try {
                    val field = `object`.javaClass.getDeclaredField(key)
                    field.isAccessible = true
                } catch (e: NoSuchFieldException) {
                    e.printStackTrace()
                }

            }
        }
    }

}
