package com.cc.tools.utils

import android.util.Log


object Logger {

    val TAG = "Logger"

    var LOG_SWITCH = false

    fun v(text: Any) {
        if (LOG_SWITCH) {
            v(TAG, text)
        }
    }

    fun v(tag: Any, text: Any) {
        if (LOG_SWITCH) {
            try {
                Log.v(tag.toString(), text.toString())
            } catch (e: Exception) {
                e.printStackTrace()
            }

        }
    }

    fun i(text: Any) {
        if (LOG_SWITCH) {
            i(TAG, text)
        }
    }

    fun i(vararg objects: Any) {
        if (LOG_SWITCH) {
            val stringBuffer = StringBuffer()
            for (o in objects) {
                stringBuffer.append(o.toString()).append(" , ")
            }
            i(stringBuffer)
        }
    }

    fun i(TAG: String, str: Any) {
        if (LOG_SWITCH) {
            try {
                Log.i(TAG.toString(), str.toString())
            } catch (e: Exception) {
                e.printStackTrace()
            }

        }
    }

    fun d(text: Any) {
        if (LOG_SWITCH) {
            d(TAG, text)
        }
    }

    fun d(TAG: Any, str: Any) {
        if (LOG_SWITCH) {
            try {
                Log.d(TAG.toString(), str.toString())
            } catch (e: Exception) {
                e.printStackTrace()
            }

        }
    }

    fun e(text: Any) {
        if (LOG_SWITCH) {
            e(TAG, text)
        }
    }

    fun e(TAG: Any, str: Any) {
        if (LOG_SWITCH) {
            e(TAG, str, null)
        }
    }

    fun e(TAG: Any, str: Any, tr: Throwable?) {
        if (LOG_SWITCH) {
            try {
                Log.e(TAG.toString(), str.toString(), tr)
            } catch (e: Exception) {
                e.printStackTrace()
            }

        }
    }

    fun w(text: Any) {
        if (LOG_SWITCH) {
            w(TAG, text)
        }
    }

    fun w(TAG: Any, str: Any) {
        if (LOG_SWITCH) {
            w(TAG, str, null)
        }
    }

    fun w(TAG: Any, str: Any, tr: Throwable?) {
        if (LOG_SWITCH) {
            try {
                Log.w(TAG.toString(), str.toString(), tr)
            } catch (e: Exception) {
                e.printStackTrace()
            }

        }
    }

}