package com.cc.tools.utils

import java.io.File
import java.math.BigInteger
import java.security.MessageDigest

/**
 * 采用MD5加密解密
 *
 * @author tfq
 * @datetime 2011-10-13
 */
object MD5Util {

    /***
     * MD5加码 生成32位md5码
     */
    fun string2MD5(inStr: String): String {
        val byteArray = inStr.toByteArray()
        return hexDigest(byteArray)
    }

    fun hexDigest(bytes: ByteArray): String {
        val md5: MessageDigest
        try {
            md5 = MessageDigest.getInstance("MD5")
        } catch (e: Exception) {
            e.printStackTrace()
            return ""
        }

        val md5Bytes = md5.digest(bytes)
        val hexValue = StringBuffer()
        for (i in md5Bytes.indices) {
            val `val` = md5Bytes[i].toInt() and 0xff
            if (`val` < 16)
                hexValue.append("0")
            hexValue.append(Integer.toHexString(`val`))
        }
        return hexValue.toString()
    }

    /**
     * 加密解密算法 执行一次加密，两次解密
     */
    fun convertMD5(inStr: String): String {
        val a = inStr.toCharArray()
        for (i in a.indices) {
            a[i] = (a[i].toInt() xor 't'.toInt()).toChar()
        }
        return String(a)

    }

    // 测试主函数
    @JvmStatic
    fun main(args: Array<String>) {
        val s = "tangfuqiang"
        println("原始：" + s)
        println("MD5后：" + string2MD5(s))
        println("加密的：" + convertMD5(s))
        println("解密的：" + convertMD5(convertMD5(s)))

    }

    //获取文件MD5值
    fun getFileMD5(file: File): String? {
        if (!file.isFile) {
            return null
        }
        var digest: MessageDigest? = null
        try {
            digest = MessageDigest.getInstance("MD5")
            digest!!.update(file.readBytes())
        } catch (e: Exception) {
            e.printStackTrace()
            return null
        }

        val bigInt = BigInteger(1, digest!!.digest())
        val builder = StringBuilder(bigInt.toString(16))
        while (builder.length < 32) {
            builder.insert(0, '0')
        }
        return builder.toString()
    }

}
