package com.cc.tools.utils

import java.util.*


object StrUtils {

    internal val digits = "0123456789ABCDEF"
    val DEFAULT_ENCODE = "utf8"

    fun countStr(parent: String, sep: String?): Int {
        if (sep == null || sep.length == 0) return 0
        var p = parent
        var count = 0
        while (true) {
            val idx = p.indexOf(sep)
            if (idx == -1)
                break
            else {
                count++
                p = p.substring(idx + sep.length)
            }
        }
        return count
    }

    fun removeHost(url: String): String {
        var url = url
        if (url.startsWith("http://")) {
            url = url.substring(7)
        } else if (url.startsWith("https://")) {
            url = url.substring(8)
        }
        for (idx in 0 until url.length) {
            if (url[idx] == '/') {
                url = url.substring(idx)
                break
            }
        }
        return url
    }

    @JvmOverloads
    fun skipEmptyLetters(str: String, start: Int = 0): Int {
        var idx = start
        while (idx < str.length) {
            if (!isEmptyLetter(str[idx]))
                break
            ++idx
        }
        return idx
    }

    fun removeSuffix(str: String): String {
        val index = str.lastIndexOf('.')
        return if (index < 0)
            str
        else
            str.substring(0, index)
    }


    fun isEmptyLetter(ch: Char): Boolean {
        return ch == ' ' || ch == '\t' || ch == '\n' || ch == '\r'
    }

    fun formatStr(str: String): String {
        val builder = StringBuilder()
        var ch: Char = 0.toChar()
        for (idx in 0 until str.length) {
            ch = str[idx]
            if (ch == '\r')
                continue
            builder.append(ch)
        }
        val result = builder.toString()
        return result.trim { it <= ' ' }
        // return builder.toString();
    }

    fun splitStr(parent: String, sep: String,
                 allowEmpty: Boolean): List<String> {
        val strList = ArrayList<String>()
        var pre = 0
        while (pre < parent.length) {
            var cur = pre
            while (cur < parent.length && sep.indexOf(parent[cur]) == -1) {
                ++cur
            }
            if (allowEmpty || cur > pre) {
                strList.add(parent.substring(pre, cur))
            }
            pre = cur + 1
        }
        return strList
    }


    fun splitStrWithSepStr(parent: String, sep: String, allowEmpty: Boolean): List<String> {
        val strList = ArrayList<String>()
        var pos = 0
        while (pos < parent.length) {
            val idx = parent.indexOf(sep, pos)
            if (idx == -1) {
                strList.add(parent.substring(pos))
                break
            }
            if (allowEmpty || idx > pos) {
                strList.add(parent.substring(pos, idx))
            }
            pos = idx + sep.length
        }
        return strList
    }

    fun trimStr(str: String, sep: String): String {
        for (idx in 0 until str.length) {
            val ch = str[idx]
            if (sep.indexOf(ch) != -1) {
                return str.substring(0, idx)
            }
        }
        return str
    }

    fun retriveDigit(str: String): String {
        val builder = StringBuilder()
        for (idx in 0 until str.length) {
            val ch = str[idx]
            if (ch >= '0' && ch <= '9') {
                builder.append(ch)
            }
        }
        return builder.toString()
    }

    fun getSubStr(str: String, start: Int, end: Int): String {
        var start = start
        var end = end
        if (end > str.length)
            end = str.length
        if (start < 0)
            start = 0
        return str.substring(start, end)
    }

    fun retrF(str: String): String {
        var str = str
        str = str.trim { it <= ' ' }
        val idx = str.indexOf(' ')
        return if (idx == -1)
            str
        else {
            str.substring(0, idx)
        }
    }

    fun changeNullStr(str: String): String {
        return if ("null" == str) {
            ""
        } else str
    }

    fun listToStr(strList: List<String>?, sep: Char, nullToEmpty: Boolean): String? {
        if (strList == null && nullToEmpty) {
            return ""
        }
        if (strList == null && !nullToEmpty) {
            return null
        }
        val builder = StringBuilder()
        for (idx in strList!!.indices) {
            builder.append(strList[idx])
            if (idx < strList.size - 1) {
                builder.append(sep)
            }
        }
        return builder.toString()
    }

    /**
     * Capitalize the first letter
     *
     * @param s model,manufacturer
     * @return Capitalize the first letter
     */
    fun capitalize(s: String?): String {
        if (s == null || s.length == 0) {
            return ""
        }
        val first = s[0]
        return if (Character.isUpperCase(first)) {
            s
        } else {
            Character.toUpperCase(first) + s.substring(1)
        }
    }

    //	//从指定文件夹读取内容
    //	public static List<String> getSendSharedStrings(Context context,String FileName) {
    //		List<String> list = new ArrayList<String>();
    //		try {
    //			InputStream is = context.getAssets().open(FileName);
    //			BufferedReader br = new BufferedReader(new InputStreamReader(is,DEFAULT_ENCODE));
    //			String ss = null;
    //			while ((ss = br.readLine()) != null) {
    //				list.add(ss);
    //			}
    //			br.close();
    //			is.close();
    //		} catch (Exception e) {
    //			Logger.v("StrUtils error:%s", new Object[]{e.getMessage()});
    //		}
    //		return list;
    //	}

    //	public static String UrlEncode(String s) {
    //		StringBuilder buf = new StringBuilder(s.length() + 16);
    //		for (int i = 0; i < s.length(); ++i) {
    //			char ch = s.charAt(i);
    //			if (ch == '+') {
    //				buf.append("%2B");
    //			} else if (ch == '&') {
    //				buf.append("%26");
    //			} else
    //				buf.append(ch);
    //		}
    //		return buf.toString();
    //		// StringBuilder buf = new StringBuilder(s.length() + 16);
    //		// for (int i = 0; i < s.length(); i++) {
    //		// char ch = s.charAt(i);
    //		// if ((ch >= 'a' && ch <= 'z') || (ch >= 'A' && ch <= 'Z')
    //		//                    || (ch >= '0' && ch <= '9') || ".-*_()[]^@".indexOf(ch) > -1) { //$NON-NLS-1$
    //		// buf.append(ch);
    //		// } else if (ch == ' ') {
    //		// buf.append('+');
    //		// } else {
    //		// byte[] bytes = new String(new char[] { ch }).getBytes();
    //		// for (int j = 0; j < bytes.length; j++) {
    //		// buf.append('%');
    //		// buf.append(digits.charAt((bytes[j] & 0xf0) >> 4));
    //		// buf.append(digits.charAt(bytes[j] & 0xf));
    //		// }
    //		// }
    //		// }
    //		// return buf.toString();
    //	}
}
