package com.cc.tools.utils

import android.content.Context
import android.os.Handler
import android.text.TextUtils
import android.widget.Toast


object ToastUtils {

    private var textToast: Toast? = null

    fun showShortToast(context: Context, resId: Int) {
        showToast(context, context.getString(resId), Toast.LENGTH_SHORT)
    }

    fun showShortToast(context: Context, text: String) {
        showToast(context, text, Toast.LENGTH_SHORT)
    }

    fun showLongToast(context: Context, resId: Int) {
        showToast(context, context.getString(resId), Toast.LENGTH_LONG)
    }


    fun showLongToast(context: Context, text: String) {
        showToast(context, text, Toast.LENGTH_LONG)
    }

    fun showToast(context: Context, text: String, duration: Int) {
        if (TextUtils.isEmpty(text)) return
        if (textToast != null) {
            textToast!!.setText(text)
            textToast!!.duration = duration
        } else {
            textToast = Toast.makeText(context.applicationContext, text, duration)
        }
        textToast!!.show()
    }

    fun popupToast(handler: Handler, context: Context, resId: Int, duration: Int) {
        popupToast(handler, context, context.getString(resId), duration, 0)
    }

    fun popupToast(handler: Handler, context: Context, resId: Int, duration: Int, delayMillis: Long) {
        popupToast(handler, context, context.getString(resId), duration, delayMillis)
    }

    @JvmOverloads
    fun popupToast(handler: Handler, context: Context, text: String, duration: Int, delayMillis: Long = 0) {
        HandlerUtils.postDelayed(handler, Runnable { showToast(context, text, duration) }, delayMillis)
    }

}
