package com.cc.tools.utils.start

import android.content.Context
import android.content.Intent
import com.cc.tools.R
import com.cc.tools.fragment.login.LoginFragment
import com.cc.tools.fragment.login.RegisterFragment
import com.cc.tools.fragment.login.ResetPwdFragment


object LoginModuleUtils : ModuleUtils() {

    /**
     * 跳转到登录
     *
     * @param context
     */
    fun startLoginActivity(ctx: Context) {
        startLoginActivity(ctx, "", false)
    }

    fun startLoginActivity(ctx: Context, toastText: String, later: Boolean) {
        val intent = Intent()
        intent.putExtra(TOAST, toastText)
        intent.putExtra(LATER, later)
        startActivity(ctx, LoginFragment::class.java.name, ctx.resources.getString(R.string.text_login), Intent())
    }

    /**
     * 重置密码
     */
    fun startPwdResetActivity(ctx: Context) {
        startActivity(ctx, ResetPwdFragment::class.java.name, ctx.resources.getString(R.string.text_forgot_pwd), Intent())
    }

    /**
     * 注册
     */
    fun startRegisterActivity(ctx: Context) {
        startActivity(ctx, RegisterFragment::class.java.name, ctx.resources.getString(R.string.text_register), Intent())
    }

}