package com.cc.tools.widget.actionbar

import android.content.Context
import android.support.v7.widget.Toolbar
import android.util.AttributeSet
import android.view.Menu
import android.view.MenuInflater
import com.cc.tools.R
import com.cc.tools.model.common.IMenuModel
import com.cc.tools.utils.SystemBarUtils


open abstract class ActionBasicLayout : Toolbar {

    var mIMenuModel: IMenuModel? = null

    constructor(ctx: Context, set: AttributeSet) : super(ctx, set) {
        setBackgroundResource(R.drawable.tools_common_actionbar_bg)
    }

    override fun onFinishInflate() {
        super.onFinishInflate()
        setPadding(paddingLeft, paddingTop + SystemBarUtils.mActionBarHeight, paddingRight, paddingBottom)
    }

    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        super.onMeasure(widthMeasureSpec, MeasureSpec.makeMeasureSpec(suggestedMinimumHeight + paddingTop, MeasureSpec.EXACTLY))
    }

    override fun getCurrentContentInsetStart(): Int {
        return 0
    }

    override fun getCurrentContentInsetLeft(): Int {
        return 0
    }

    override fun getCurrentContentInsetRight(): Int {
        return 0
    }

    override fun getCurrentContentInsetEnd(): Int {
        return 0
    }

    open fun setLeftIcon(resIcon: Int) {

    }

    open fun onCreateOptionsMenu(menu: Menu?, inflater: MenuInflater?) {
    }

}