package com.cc.tools.widget.actionbar.menu

import android.content.Context
import android.util.AttributeSet
import android.view.Gravity
import android.widget.TextView
import com.cc.tools.R
import com.cc.tools.utils.DisplayUtils

/**
 * 文本按钮
 */
class ActionbarMenuTextView : TextView {

    constructor(context: Context) : super(context) {
        val padding = DisplayUtils.dip2px(getContext(), 15f)
        setPadding(padding, 0, padding, 0)
        setBackgroundResource(R.drawable.drawable_selector_transparent)
        gravity = Gravity.CENTER
        setTextColor(resources.getColor(R.color.color_common_white))
        textSize = 14f
    }

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {}

    override fun setCompoundDrawablesWithIntrinsicBounds(left: Int, top: Int, right: Int, bottom: Int) {
        super.setCompoundDrawablesWithIntrinsicBounds(left, top, right, bottom)
        compoundDrawablePadding = DisplayUtils.dip2px(context, 7.5f)
    }

}
