package com.cc.tools.widget.drawable

import android.content.res.ColorStateList
import android.graphics.*
import android.graphics.drawable.ColorDrawable
import com.cc.tools.application.BaseApplication


open class DrawableCircleRect : ColorDrawable {

    lateinit var mColorSateList: ColorStateList

    constructor() {

    }

    constructor(colorStateList: ColorStateList) {
        mColorSateList = colorStateList
    }

    constructor(color: Int) : super(color) {

    }

    var mPaint = Paint(Paint.ANTI_ALIAS_FLAG)
    var mRectF = RectF()

    override fun draw(canvas: Canvas) {
        canvas.save()
        if (mColorSateList == null) {
            mPaint.color = color
        } else {
            mPaint.color = mColorSateList.getColorForState(state, color)
        }
        var res = BaseApplication.mApplication.resources
        canvas.drawRoundRect(mRectF, mRectF.height() / 2, mRectF.height() / 2, mPaint)
        canvas.restore()
    }

    override fun setAlpha(alpha: Int) {

    }

    override fun getOpacity(): Int {
        return PixelFormat.OPAQUE
    }

    override fun onBoundsChange(bounds: Rect) {
        super.onBoundsChange(bounds)
        mRectF.set(bounds)
    }

    override fun setColorFilter(colorFilter: ColorFilter) {
    }

    open fun onDestroy() {

    }
}