package com.cc.tools.widget.icon

import android.content.Context
import android.graphics.Canvas
import android.util.AttributeSet
import android.widget.ImageView
import com.cc.tools.utils.helper.RoundLayoutHelper


open class RoundIcon : ImageView {

    private var mRoundLayoutHelper: RoundLayoutHelper? = null

    constructor(context: Context, set: AttributeSet) : super(context, set) {
        mRoundLayoutHelper = RoundLayoutHelper(this)
        mRoundLayoutHelper!!.mIsCircle = true
    }

    override fun draw(canvas: Canvas) {
        val saveCount = canvas.saveLayer(0f, 0f, width.toFloat(), height.toFloat(), null, Canvas.ALL_SAVE_FLAG)
        super.draw(canvas)
        mRoundLayoutHelper!!.draw(canvas, saveCount)
    }


    override fun onLayout(changed: Boolean, l: Int, t: Int, r: Int, b: Int) {
        super.onLayout(changed, l, t, r, b)
        mRoundLayoutHelper!!.setRoundRadius(width / 2)
        mRoundLayoutHelper!!.onLayout(width, height)
    }

}
