package com.cc.tools.widget.input

import android.content.Context
import android.graphics.Canvas
import android.graphics.Color
import android.graphics.Paint
import android.graphics.RectF
import android.util.AttributeSet
import android.view.Gravity
import android.widget.EditText
import com.cc.tools.utils.DisplayUtils

/**
 * 绑定手机
 */
class BindPhoneInput : EditText {

    var mRoundRect: RectF = RectF()
    var mLineHeight = 0
    var mPaint = Paint(Paint.ANTI_ALIAS_FLAG)

    constructor(ctx: Context, set: AttributeSet) : super(ctx, set) {
        gravity = Gravity.CENTER
//        textSize = 17.toFloat()
        mLineHeight = DisplayUtils.dip2px(ctx, 0.5f)
    }

    override fun onDraw(canvas: Canvas) {
        super.onDraw(canvas)
        canvas.save()
        var radius = height / 2.toFloat()
//        mPaint.style = Paint.Style.STROKE
        mPaint.color = Color.BLUE
//        resources.getColor(R.color.color_line)
        canvas.drawRect(mRoundRect, mPaint)
        canvas.restore()
    }

//    override fun drawClearDrawable(canvas: Canvas) {
////        super.drawClearDrawable(canvas)
//    }
//
//    override fun drawRect(canvas: Canvas) {
////        super.drawRect(canvas)
//    }

    override fun onLayout(changed: Boolean, left: Int, top: Int, right: Int, bottom: Int) {
        super.onLayout(changed, left, top, right, bottom)
        mRoundRect.left = mLineHeight.toFloat()
        mRoundRect.top = mLineHeight.toFloat()
        mRoundRect.right = width.toFloat() - mLineHeight
        mRoundRect.bottom = height.toFloat() - mLineHeight
    }

}