package com.cc.tools.widget.layout

import android.content.Context
import android.util.AttributeSet
import android.view.View
import android.widget.ScrollView

import com.cc.tools.utils.DisplayUtils

class CheckUpdatesScrollView(context: Context, attrs: AttributeSet) : ScrollView(context, attrs) {

    internal var mMaxHeight: Int = 0

    init {
        mMaxHeight = DisplayUtils.dip2px(getContext(), 180f)
    }

    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        super.onMeasure(widthMeasureSpec, heightMeasureSpec)
        val height = measuredHeight
        if (height > mMaxHeight) {
            super.onMeasure(widthMeasureSpec, View.MeasureSpec.makeMeasureSpec(mMaxHeight, View.MeasureSpec.EXACTLY))
        }
    }

}
