package com.cc.tools.widget.layout

import android.content.Context
import android.graphics.Canvas
import android.util.AttributeSet
import android.widget.LinearLayout
import com.cc.tools.R
import com.cc.tools.utils.helper.RoundLayoutHelper


class DlgLinearLayout : LinearLayout {

    private var mRoundLayoutHelper: RoundLayoutHelper? = null

    constructor(context: Context) : super(context) {
        init(null)
    }

    constructor(context: Context, attrs: AttributeSet) : super(context, attrs) {
        init(attrs)
    }

    constructor(context: Context, attrs: AttributeSet, defStyleAttr: Int) : super(context, attrs, defStyleAttr) {
        init(attrs)
    }

    constructor(context: Context, attrs: AttributeSet, defStyleAttr: Int, defStyleRes: Int) : super(context, attrs, defStyleAttr, defStyleRes) {
        init(attrs)
    }

    private fun init(set: AttributeSet?) {
        mRoundLayoutHelper = RoundLayoutHelper(this)
        if (set != null) {
            var attrs = intArrayOf(R.attr.radius)
            val typedArray = context.obtainStyledAttributes(set, attrs)
            mRoundLayoutHelper!!.setRoundRadius(typedArray.getDimensionPixelOffset(0, 10))
            typedArray.recycle()
        } else {
            mRoundLayoutHelper!!.setRoundRadius(10)
        }
        orientation = VERTICAL
        setBackgroundResource(R.color.color_common_white)
    }

    override fun draw(canvas: Canvas) {
        val saveCount = canvas.saveLayer(0f, 0f, width.toFloat(), height.toFloat(), null, Canvas.ALL_SAVE_FLAG)
        super.draw(canvas)
        mRoundLayoutHelper!!.draw(canvas, saveCount)
    }


    override fun onLayout(changed: Boolean, l: Int, t: Int, r: Int, b: Int) {
        super.onLayout(changed, l, t, r, b)
        mRoundLayoutHelper!!.onLayout(width, height)
    }

}
