package com.cc.tools.widget.reclyer

import android.app.Activity
import android.content.Context
import android.content.res.Resources
import android.support.annotation.StringRes
import android.support.v7.widget.RecyclerView
import android.support.v7.widget.RecyclerView.ViewHolder
import android.view.View

open class BaseHolder<T>
//    protected RecyclerView.Adapter mAdapter;

(itemView: View, adapter: RecyclerView.Adapter<*>)//        mAdapter = adapter;
    : ViewHolder(itemView) {

    val context: Context
        get() = itemView.context

    protected val resources: Resources
        get() = context.resources

    val isFinishing: Boolean
        get() {
            if (itemView == null) return true
            val context = itemView.context
            return (context as? Activity)?.isFinishing ?: true
        }

    open fun setEntityData(t: T, position: Int) {

    }

    protected fun getString(id: Int): String {
        return resources.getString(id)
    }

    protected fun getString(@StringRes id: Int, vararg formatArgs: Any): String {
        return resources.getString(id, *formatArgs)
    }

    protected fun findViewById(id: Int): View {
        return itemView.findViewById(id)
    }

}