package com.cc.tools.widget.text

import android.content.Context
import android.graphics.Canvas
import android.graphics.drawable.Drawable
import android.util.AttributeSet
import android.widget.TextView
import com.cc.tools.R

class DlgBtnView(context: Context, attrs: AttributeSet?) : TextView(context, attrs) {

    private val mLineDrawable: Drawable

    init {
        mLineDrawable = resources.getDrawable(R.color.color_common_line)
    }

    override fun onDraw(canvas: Canvas) {
        super.onDraw(canvas)
        canvas.save()
        mLineDrawable.draw(canvas)
        canvas.restore()
    }

    override fun onLayout(changed: Boolean, left: Int, top: Int, right: Int, bottom: Int) {
        var left = left
        var top = top
        var right = right
        var bottom = bottom
        super.onLayout(changed, left, top, right, bottom)
        left = 0
        top = 0
        right = width
        bottom = resources.getDimensionPixelSize(R.dimen.common_line)
        mLineDrawable.setBounds(left, top, right, bottom)
    }
}
