package com.cc.tools.widget.text

import android.content.Context
import android.graphics.Canvas
import android.graphics.drawable.Drawable
import android.util.AttributeSet
import android.widget.TextView
import com.cc.tools.R

class DlgTitleView(context: Context, attrs: AttributeSet?) : TextView(context, attrs) {

    private val mLineDrawable: Drawable
    private val mPadding: Int

    init {
        mPadding = resources.getDimensionPixelOffset(R.dimen.common_margin)
        mLineDrawable = resources.getDrawable(R.color.color_common_line)
    }

    override fun onDraw(canvas: Canvas) {
        super.onDraw(canvas)
        canvas.save()
        mLineDrawable.draw(canvas)
        canvas.restore()
    }

    override fun onLayout(changed: Boolean, left: Int, top: Int, right: Int, bottom: Int) {
        var left = left
        var top = top
        var right = right
        var bottom = bottom
        super.onLayout(changed, left, top, right, bottom)
        left = mPadding
        top = height - resources.getDimensionPixelSize(R.dimen.common_line)
        right = width - mPadding
        bottom = height
        mLineDrawable.setBounds(left, top, right, bottom)
    }
}